import java.util.*

class ForthEvaluator {
    val stack: Stack<String> = Stack<String>()
    val overridenOperators = mutableMapOf<Char, Char>()

    private val validOps = listOf<String>("+", "-", "*", "/", "dup", "drop", "swap", "over")

    fun evaluateProgram(inpList: List<String>): List<Int>{
        for (i in inpList){
            val tokenized = i.split(' ')
            tokenized.all { validateToken(it) }
            for (j in tokenized){
                stack.push(j)
            }
        }
        return emptyList()

    }
    private fun validateToken(token: String): Boolean {
        if (token !in validOps) {
            try {
                token.toInt()
            } catch (e: NumberFormatException) {
                if (token !in validOps) {
                    throw IllegalArgumentException("No definition available for operator \"$token\"")
                }
            }
        }
        return true
    }
}

fun main(args: Array<String>) {
    print(ForthEvaluator().evaluateProgram(listOf("1 2 3 4")))
}